unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  Db, DBTables, ToolEdit, StdCtrls, DBGrids, Grids,
  ExtCtrls, ARWordReport, Buttons, Mask;

type
  TForm1 = class(TForm)
    WordReport1: TARWordReport;
    m1: TMemo;
    FilenameEdit1: TFilenameEdit;
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Label2: TLabel;
    Query1: TQuery;
    Label3: TLabel;
    Label4: TLabel;
    Label1: TLabel;
    Label5: TLabel;
    Bevel1: TBevel;
    Label6: TLabel;
    Button1: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure WordReport1Tag(Sender: TObject; var TagValue: String);
    procedure WordReport1NeedSQL(Sender: TObject; SQLstring: String;
      var ResultDataset: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

//uses VerInfo;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Query1.DatabaseName:= ExtractFileDir(Application.ExeName);
  Table1.DatabaseName:= Query1.DatabaseName;
  Table1.Open;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  WordReport1.Filename:= FilenameEdit1.FileName; //Template
  WordReport1.CustTagValues.Assign(m1.Lines);
  // It is enough to use only Preview method
  // in most cases when you work with TARWordReport.
  WordReport1.Preview;
  Query1.Close;
  Query1.SQL.Clear;
end;

procedure TForm1.WordReport1Tag(Sender: TObject; var TagValue: String);
begin
  // Using OnTag Event
  TagValue:= AnsiUpperCase(TagValue);
  if TagValue='NOWDATE' then TagValue:= DateToStr(now)
  else if TagValue='NOWTIME' then TagValue:= TimeToStr(now)
  else TagValue:='';
end;

procedure TForm1.WordReport1NeedSQL(Sender: TObject; SQLstring: String;
  var ResultDataset: TDataSet);
begin
  // ResultDataset=nil
  // You need to point it to your dataset
  try
    //Check SQLstring here if needed
    //(like a ARWordReportPerfom.CheckQuery function)
    Query1.Close;
    Query1.SQL.Clear;
    Query1.SQL.Add(SQLstring);
    Query1.Open;
    ResultDataset:= Query1;
  except
    ResultDataset:= nil;
  end;
end;

end.
